#!/bin/bash
##usage - run script on Nuke file: "path to script" "path to .nk file"
##v1.1: now makes a relinked copy of the script 
##v1.2: added a uniq line stripping so it wouldn't trip over duplicated read nodes
##v1.3: now works with paths with spaces in them (this will still trip error check though, so use other script)
##v1.3.1: minor change to better translate numbers ([0-9]*) in the copy command instead of just a generic (*) catchall wildcard that could trip up some copies.

echo "Enter path for script collection or drag folder in Terminal window and hit Enter (no spaces in destination path name or relink fails):";
read writeDir;
echo Script will now collect all files and Nuke script to this folder: $writeDir;
mkdir "$writeDir/source_images_films_and_geo" & 

##Build file list from Nuke script
##lines with quotes
cat "$1" | sed '/Write/,/}/d' | grep file | grep -v file_type | awk '!/file \// {print $0}' | sed 's/%0[0-9]d/[0-9]*/g' | sed 's/file //' | sed "s%.*%cp -iR & '$writeDir/source_images_films_and_geo'/%" | uniq > /tmp/nukeCollection.sh;
##lines without quotes
cat "$1" | sed '/Write/,/}/d' | grep file | grep -v file_type | awk '/file \// {print $0}' | sed 's/%0[0-9]d/[0-9]*/g' |  sed 's/file //' | sed "s%.*%cp -iR & '$writeDir/source_images_films_and_geo'/%" | uniq >> /tmp/nukeCollection.sh; 

chmod +x /tmp/nukeCollection.sh;

##copy files and script to destination
/tmp/nukeCollection.sh;
cp -i "$1" "$writeDir/" ;

##make a relinked copy of the Nuke script (God rays appear here)

##process lines with no quotes
cat "$1" | sed "s%file \/.*\/%file $writeDir\/source_images_films_and_geo\/%g" | sed "s%file \"\/.*\/%file \"$writeDir\/source_images_films_and_geo\/%g" > "$writeDir/nuke_scene_copy_relinked.nk"